﻿using UnityEngine;
using System.Collections;

public class DecisionTree {

    public delegate bool Decision();
    public   Decision decision;
    public delegate void Action();
    public Action action;
    public DecisionTree rightLeaf;
    public DecisionTree leftLeaf;

    public DecisionTree() {
        rightLeaf = null;
        leftLeaf = null;
    }

    public void setDecision(Decision d) {
        decision = d;
    }

    public void setAction(Action a) {
        action += a;
    }

    public void setLeft(DecisionTree node) {
        if (decision() == true) {
            leftLeaf = node;
        }
    }

    public void setRight(DecisionTree node) {
        if (decision() == false) {
            rightLeaf = node;
        }
    }

    public bool isLeaf(DecisionTree node) {
        if (rightLeaf == null && leftLeaf == null) {
            return true;
        }
        return false;
    }

    public void search(DecisionTree node) {

        if (isLeaf(node)) {
            node.action();
        }
        else if (node.decision() == false) {
            rightLeaf.search(node.rightLeaf);
        }
        else if (node.decision() == true) {
            leftLeaf.search(node.leftLeaf);
        }

    }
}
